"""
    QRE API

    TBD  # noqa: E501

    The version of the OpenAPI document: 0.0.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.QuantitativeResearchEnvironment.api_client import ApiClient, Endpoint as _Endpoint
from fds.sdk.QuantitativeResearchEnvironment.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from fds.sdk.QuantitativeResearchEnvironment.model.file_upload_status import FileUploadStatus


class FilesApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.analytics_quant_qre_v1_files_server_file_post_endpoint = _Endpoint(
            settings={
                'response_type': (FileUploadStatus,),
                'auth': [
                    'FactSetApiKey',
                    'FactSetOAuth2'
                ],
                'endpoint_path': '/analytics/quant/qre/v1/files/{server}/{file}',
                'operation_id': 'analytics_quant_qre_v1_files_server_file_post',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'server',
                    'file',
                    'body',
                ],
                'required': [
                    'server',
                    'file',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'server':
                        (str,),
                    'file':
                        (str,),
                    'body':
                        (file_type,),
                },
                'attribute_map': {
                    'server': 'server',
                    'file': 'file',
                },
                'location_map': {
                    'server': 'path',
                    'file': 'path',
                    'body': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    '*'
                ]
            },
            api_client=api_client
        )
        self.analytics_quant_qre_v1_files_uploads_id_get_endpoint = _Endpoint(
            settings={
                'response_type': (FileUploadStatus,),
                'auth': [
                    'FactSetApiKey',
                    'FactSetOAuth2'
                ],
                'endpoint_path': '/analytics/quant/qre/v1/files/uploads/{id}',
                'operation_id': 'analytics_quant_qre_v1_files_uploads_id_get',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'id',
                ],
                'required': [
                    'id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'id':
                        (str,),
                },
                'attribute_map': {
                    'id': 'id',
                },
                'location_map': {
                    'id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )

    def analytics_quant_qre_v1_files_server_file_post(
        self,
        server,
        file,
        **kwargs
    ):
        """Starts a file upload  # noqa: E501

        This endpoint takes a file and uploads it  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.analytics_quant_qre_v1_files_server_file_post(server, file, async_req=True)
        >>> result = thread.get()

        Args:
            server (str): The server to upload the file to. Either `interactive` or `batch`.
            file (str): The file name to upload the file to. Existing directory can be specified.

        Keyword Args:
            body (file_type): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            FileUploadStatus
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['server'] = \
            server
        kwargs['file'] = \
            file
        return self.analytics_quant_qre_v1_files_server_file_post_endpoint.call_with_http_info(**kwargs)

    def analytics_quant_qre_v1_files_uploads_id_get(
        self,
        id,
        **kwargs
    ):
        """Get upload status by id  # noqa: E501

        This is the endpoint to check on the progress of a previous upload request.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.analytics_quant_qre_v1_files_uploads_id_get(id, async_req=True)
        >>> result = thread.get()

        Args:
            id (str): From url, provided by location header or response body in the upload start endpoint

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            FileUploadStatus
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['id'] = \
            id
        return self.analytics_quant_qre_v1_files_uploads_id_get_endpoint.call_with_http_info(**kwargs)

